BIO_S_SOCKET(3)

NAME
BIO_s_socket, BIO_new_socket - socket BIO

SYNOPSIS
#include <openssl/bio.h>
BIO_METHOD *
BIO_s_socket(void);
BIO *
BIO_new_socket(int sock, int close_flag);

DESCRIPTION
BIO_s_socket() returns the socket BIO method. This is a wrapper around the platform's socket routines.

BIO_read(3) and BIO_write(3) read or write the underlying socket. BIO_puts(3) is supported but BIO_gets(3) is not.

If the close flag is set, then the socket is shut down and closed when the BIO is freed.

BIO_new_socket() returns a socket BIO using sock and close_flag.

Socket BIOs also support any relevant functionality of file descriptor BIOs.

The reason for having separate file descriptor and socket BIOs is that on some platforms, sockets are not file descriptors and use distinct I/O routines. Windows is one such platform. Any code mixing the two will not work on all platforms.

RETURN VALUES
BIO_s_socket() returns the socket BIO method.

BIO_new_socket() returns the newly allocated BIO or NULL if an error occurred.

SEE ALSO
BIO_get_fd(3), BIO_new(3)